(****
autor/author.....:	mariano d. podesta - marianop@intercom.com.ar
fecha/date.......:	03/1999
contiene/contents:	POP3 client - version 1.7
notas/notes......:  *** WORKS WITH ALL SOCKET IMPLEMENTATIONS ***
										if u hate comments, just kill 'em all!
****)
unit wlpop3;

interface

uses
	SysUtils, Classes, Windows;

	//	attention!
	//	i had changed my e-mail address to marianop@intercom.com.ar
	//	please send me mails to this address

	{	history:
						version notation (i use):

						x.x.x
						| | |
						| |	+-- one or more bugs fixed
						| +---- updates or minor changes
						+------ added features or big changes

		1.0			first release
		1.1			added TMailPart.GetAttachmentInfo
						modified TMailMessage.GetAttachedList (updated)
						modified TMailMessage.GetAttachedNames (updated)
						modified TMailMessage.GetAttachedCount (updated)
						modified TMailMessage.SaveAttachedToStream (updated)
						modified TWirelessPOP3.InternalBodyProc (minor change)
						added TMailPart.GetTextInfo
						modified TMailMessage.GetMainText (updated)
		1.2.1   --BUG-->> fixed TMailMessageList.ClearList (bug: missing 'Clear')
						modified TMailMessage.Create (change: init 'FSize')
						modified TWirelessPOP3.InternalRetrieveMessageProc (change: read size)
						deleted TWirelessPOP3.InternalExtractParams
						added f_ExtractParams (as tool function)
		1.2.2		modified TISO8859_1Decoder.DecodeLine (little optimization)
						added some comments
						modified TMIMELabel.AddValue (just a detail)
						modified TMailPart.GetAttachmentInfo (improved text comparision)
						modified TMailMessage.GetLabel
						modified TMailMessage.SaveAttachedToStream
						modified TMIMEDecoderList.IndexOf
						modified TMIMELabel.GetParameter
						modified TMailMessage.SaveAttachedToFile (small change for good looking)
						modified TMIMEDecoder.Decode (error verification)
						modified TWirelessPOP3.InternalGetMessage (optimization)
						--BUG-->> at 'Exception.Create' i forgot 'raise' (-do u know delphi?)
						--BUG-->> TUUDecoder.DecodeLine (added seek for 'begin' and 'end')
		1.3     changed OnSuccessXXX and OnErrorXXX by OnXXXOk and OnXXXError
							*** NOTE ***
							probably someone will hates me for do that,
							but i believe that compatibility is an obstacle to evolution.
							sorry, and forgive me ;-)
							************
						added event OnRetrieveAllHeadersOk
						added event OnRetrieveAllHeadersAborted
						added event OnRetrieveAllMessagesOk
						added event OnRetrieveAllMessagesAborted
						added event OnRetrieveAllUIDLsOk
						added event OnRetrieveAllUIDLsAborted
						added event OnDeleteAllMessagesOk
						added event OnDeleteAllMessagesAborted
						added method TWirelessPOP3.CurrentMessage
						added TWirelessPOP3.DoRetrieveAllHeadersOk (private)
						added TWirelessPOP3.DoRetrieveAllHeadersAborted (private)
						added TWirelessPOP3.DoRetrieveAllMessagesOk (private)
						added TWirelessPOP3.DoRetrieveAllMessagesAborted (private)
						added TWirelessPOP3.DoRetrieveAllUIDLsOk (private)
						added TWirelessPOP3.DoRetrieveAllUIDLsAborted (private)
						added TWirelessPOP3.DoDeleteAllMessagesOk (private)
						added TWirelessPOP3.DoDeleteAllMessagesAborted (private)
						added TWirelessPOP3.InternalCheckPendingCall (support for pending calls)
						added TWirelessPOP3.InternalCheckMessageCount (support for pending calls)
						modified TWirelessPOP3.InternalRetrieveHeaderProc (updated)
						modified TWirelessPOP3.InternalRetrieveHeaderProc (best control)
						modified TWirelessPOP3.InternalRetrieveMessageProc (best control)
						modified TWirelessPOP3.InternalRetrieveUIDLProc (updated)
						modified TWirelessPOP3.InternalRetrieveHeader (no more raise)
						modified TWirelessPOP3.InternalRetrieveMessage (no more raise)
						modified TWirelessPOP3.InternalRetrieveUIDL (no more raise)
						modified TWirelessPOP3.InternalDeleteMessage (no more raise)
						added TWirelessPOP3.InternalPrepare (private)
						added f_MailDateToDateTime (mail format date to 'TDateTime')
						modified TWirelessPOP3.ReadData (support for pending calls)
						modified TWirelessPOP3.RetrieveAllHeaders (retrieve message count)
						modified TWirelessPOP3.RetrieveAllMessages (retrieve message count)
						modified TWirelessPOP3.DeleteAllMessages (retrieve message count)
						deleted f_TrimList (no more needed)
		1.3.1		--BUG-->> when CR+LF was not received after response (now fixed)
						modified TWirelessPOP3.InternalRetrieveHeaderProc (fixed)
						modified TWirelessPOP3.InternalRetrieveMessageProc (fixed)
		1.3.2   --BUG-->> TMIMELabel.AddValue (error storing label)
						--BUG-->> TMailMessage.GetLabel (incomplete charset scan)
		1.3.3   *** thanks to ruslan popov for feedback ***
						--BUG-->> TWirelessPOP3.InternalExamine (eol premature -mmm..!)
		1.4			added TMailPart.GetContentInfo (more general info)
						deleted TMailPart.GetAttachmentInfo (replaced by TMailPart.GetContentInfo)
						deleted TMailPart.GetTextInfo (replaced by TMailPart.GetContentInfo)
						modified TMailMessage.GetAttachedList (updated)
						modified TMailMessage.GetMainText (for little mails without 'text/plain')
						modified TMailMessage.SaveAttachedToStream (suport for quoted-printable)
						modified TWirelessPOP3.InternalRetrieveMessage (clear mailparts list)
		1.5			added TDefaultDecoder class
						replaced all OnXXXError by single OnError (evolution bla bla bla...)
						replaced all OnXXXOk by OnXXX (events are more close to vcl now)
						replaced all OnXXXAborted by OnAbort
						replaced all OnXXXAccepted by OnAccept
						--BUG-->> TWirelessPOP3.InternalRetrieveMessage (clear a wrong list)
						modified TWirelessPOP3.InternalBodyProc (more controls)
						TMailMessage.GetAttachedCount (some attached files figures as
						TMailMessage.GetAttachedNames (inline or another variants,
						TMailMessage.GetAttachedList  (so i decided to just check 'filename'
						TMailMessage.GetMainText      (instead of 'attachment', it's ok?)
		1.5.1   --BUG-->> f_ExtractParams (works bad when use with UIDL)
						changed f_MailDateToDateTime (minor change)
						added TWirelessPOP3.DoProgress event (for messages)
						changed TMailMessage.SaveAttachedToStream (updated)
		1.5.2   --BUG-->> TWirelessPOP3.ReadData (quit without login was incomplete)
		1.5.3		property State
		1.5.4		modified p_TimeOffset
		1.6			added property TWirelessPOP3.StoreRawData (enable write raw data)
						added property TMailMessage.RawData (text lines as received from server)
		1.6.1		--BUG-->> function f_MailDateToDateTime (now it works!)
						added TQuotedPrintableDecoder class
						added TWindows1252 class
		1.7			added blocking support (can be used with blocking sockets more easy)
						added TWirelessPOP3.OnBlockingRead (for blocking support)
						changed TWirelessPOP3.Login (updated)
						changed TWirelessPOP3.Logout (updated)
						changed TWirelessPOP3.RetrieveMessageList (updated)
						changed TWirelessPOP3.RetrieveMailDropInfo (updated)
						changed TWirelessPOP3.RetrieveHeader (updated)
						changed TWirelessPOP3.RetrieveMessage (updated)
						changed TWirelessPOP3.RetrieveUIDL (updated)
						changed TWirelessPOP3.RetrieveAllHeaders (updated)
						changed TWirelessPOP3.RetrieveAllMessages (updated)
						changed TWirelessPOP3.RetrieveAllUIDLs (updated)
						changed TWirelessPOP3.DeleteAllMessages (updated)
						--BUG-->> TMailMessage.GetLabel (it hangs when can't find decoder)
	}

	{ NOTA (espaol):

		este componente intenta ofrecer un nivel de control **digno** sobre el
		protocolo POP3, con la posibilidad adicional de conectar a cualquier
		dispositivo de transporte (socket, pipe, su imaginacion...)
		sin restringir (opuesto a todos los demas componentes de POP3) a
		sockets sincronicos (bloqueantes).

		--detalles--
		hay 2 problemas para interpretar un e-mail:
			a.el texto del e-mail se expresa en cualquier set de caracteres (charset).
			b.los archivos adjuntos se codifican con cualquier algoritmo.
		para solucionar esto, el componente tiene la propiedad 'Decoders' (TMIMEDecoderList).
		esta propiedad contiene la lista de decodificadores que se pueden usar.

			por defecto 'Decoders' incluye:
			us-ascii (para charset),
			iso-8859-1 (para charset),
			base64 (para adjuntos) y
			uuencode (para adjuntos).

		si se necesita un decodificador que no esta en la lista, se agrega de la
		siguiente manera:
			a.se declara una clase que derive de TMIMEDecoder
			b.se sobreescriben los metodos DecodeLine (obligatorio) y Decode (opcional)
			c.se agrega a 'Decoders' el nombre de la clase
				ejemplos:
					1.WirelessPOP31.Decoders.Add(TMiDecoder);	// solo el nombre de la clase
					2.ver la declaracion e implementacion de TBase64Decoder y TISO8859_1Decoder
				nota: si crea algun decoder, por favor enviemelo!

		--atencion--
		1.esta diseado para delphi 3, pero tambien funca con delphi 4.
		2.los rutinas uudecode y base64decode fueron tomadas de 'SakEmail.pas'
			de Sergio Kessler (sergio@perio.unlp.edu.ar) y modificados.
		3.si encuentra un error, modifica el codigo o tiene una sugerencia,
			por favor envieme un e-mail.
		----------------------------------------------------------------------------

		NOTE (english):

		this component tries to offer a **suitable** level of control over POP3
		protocol, with the additional possibility to connect to any transport
		device (socket, pipe, your imagination...) without restrain (opposite to
		all POP3 components) to synchronical sockets (blocking).

		--details--
		there are 2 problems to parse an e-mail:
			a.e-mail text is expressed in any charset
			b.attached files are coded with any algorithm
		to solve this, the component has a property named 'Decoders' (TMIMEDecoderList).
		this property contains the usable decoders list.

			by default 'Decoders' includes:
			us-ascii (for charset),
			iso-8859-1 (for charset),
			base64 (for attachments) and
			uuencode (for attachments).

		if you need a non listed decoder, you can add it as follows:
			a.declare a TMIMEDecoder descendant class
			b.override methods DecodeLine (needed) and Decode (optional)
			c.add to 'Decoders' just the class name
				examples:
					1.WirelessPOP31.Decoders.Add(TMyDecoder);	// just the class name
					2.see declaration and implementation of TBase64Decoder and TISO8859_1Decoder
				note: if you create a decoder, please send me it!

		--attention--
		1.this component is designed for delphi 3, but works on delphi 4 too.
		2.uudecode and base64decode routines were copied from 'SakEmail.pas'
			by Sergio Kessler (sergio@perio.unlp.edu.ar) and modified.
		3.if you find an error or you modify the code or have a suggestion,
			please e-mail me.
	}

type
	TWirelessPOP3 = class;
	TMIMEDecoder = class;
	TMIMEDecoderClass = class of TMIMEDecoder;
	TMailMessage = class;

	TMIMEContentInfo = record
		ContentType: String;
		Name: String;
		ContentID: String;
		TransferEncoding: String;
		TransferDecoder: TMIMEDecoderClass;
		Disposition: String;
		FileName: String;
		Charset: String;
		CharsetDecoder: TMIMEDecoderClass;
		Body: TStringList;
	end;

	{ TMIMELabel

		property Name: String;
		nombre de la etiqueta (ej: 'Subject')

		property Value: TStringList;
		valor relacionado a la etiqueta (ej: 'Mensaje de prueba')

		property Parameters: TStringList;
		lista de parametros de la etiqueta (ej: 'charset="iso-8859-1"')
	}

	TMIMELabel = class
	private
		FName: String;
		FValue: TStringList;
		FParameters: TStringList;
		function AddParameter(const Name, Value: String): String;
		function GetParameter(const Name: String): String;
		procedure AddValue(const Value: String);
	public
		destructor Destroy; override;
		property Name: String read FName;
		property Value: TStringList read FValue;
		property Parameters: TStringList read FParameters;
	end;

	{ TMIMELabelList }

	TMIMELabelList = class(TList)
	private
		function Get(const Index: Integer): TMIMELabel;
		function AddLabel(const Name: String): TMIMELabel;
		function GetLabel(const Name: String): TMIMELabel;
	public
		destructor Destroy; override;
		property Items[const Index: Integer]: TMIMELabel read Get; default;
	end;

	{ TMailPart

		function GetContentInfo(var Info: TMIMEContentInfo): Boolean;
		llena la estructura con informacion de un contenido

		property MIMELabels: TMIMELabelList;
		lista de etiquetas (ej: From, Subject, Content-type, etc)

		property Body: TStringList;
		texto correspondiente a la seccion
	}

	TMailPart = class
	private
		FMIMELabels: TMIMELabelList;
		FBody: TStringList;
		FMailMessage: TMailMessage;
	public
		constructor Create;
		destructor Destroy; override;
		function GetContentInfo(var Info: TMIMEContentInfo): Boolean;
		property MIMELabels: TMIMELabelList read FMIMELabels;
		property Body: TStringList read FBody;
	end;

	{ TMailPartList }

	TMailPartList = class(TList)
	private
		function Get(const Index: Integer): TMailPart;
	public
		procedure ClearList;
		destructor Destroy; override;
		property Items[const Index: Integer]: TMailPart read Get; default;
		function Last: TMailPart;
	end;

	{ TMailMessage

		function GetLabel(const Name: String): String;
		devuelve el valor de la etiqueta <Name>
		(ej: GetLabel('Date') --> 'Sun, 24 Jan 1999 15:23:54 -0500')

		function GetAttachedList(List: TStrings): Boolean;
		devuelve una lista con los nombres de los archivos atachados

		function GetAttachedNames: String;
		devuelve una lista con los nombres de los archivos atachados separados por comas

		function GetAttachedCount: Integer;
		devuelve la cantidad de archivos atachados

		function SaveAttachedToStream(const FileName: String; Stream: TStream): Boolean;
		copia un archivo adjunto a un 'Stream'

		function SaveAttachedToFile(const AttachedFileName, DiskFileName: String): Boolean;
		graba un archivo adjunto a disco

		function GetMainText: String;
		devuelve el texto del mensaje

		property Number: Integer;
		contiene el numero de mail

		property Size: Integer;
		contiene el tamao en bytes del mensaje

		property XUIDL: String;
		contiene la identificacion unica del mensaje

		property MailParts: TMailPartList;
		contiene la lista de partes del mensaje
	}

	TMailMessage = class
	private
		FNumber: Integer;
		FSize: Integer;
		FXUIDL: String;
		FMailParts: TMailPartList;
		FOwner: TWirelessPOP3;
		FRawData: TStringList;
	public
		constructor Create;
		destructor Destroy; override;

		function GetLabel(const Name: String): String;
		function GetAttachedList(List: TStrings): Boolean;
		function GetAttachedNames: String;
		function GetAttachedCount: Integer;
		function SaveAttachedToStream(const FileName: String; Stream: TStream): Boolean;
		function SaveAttachedToFile(const AttachedFileName, DiskFileName: String): Boolean;
		function GetMainText: String;

		property Number: Integer read FNumber;
		property Size: Integer read FSize;
		property XUIDL: String read FXUIDL;
		property MailParts: TMailPartList read FMailParts;
		property RawData: TStringList read FRawData;
	end;

	{ TMailMessageList }

	TMailMessageList = class(TList)
	private
		function Get(const Index: Integer): TMailMessage;
	public
		destructor Destroy; override;
		procedure ClearList;
		property Items[const Index: Integer]: TMailMessage read Get; default;
	end;

	{ TMIMEDecoder }

	TProgressKind = (pkRetrieve, pkDecode);
	TProgressCallback = procedure(const Size, Current: Integer; const Kind: TProgressKind) of object;

	TMIMEDecoder = class
	public
		class function DecodeLine(const Buffer: String): String; virtual; abstract;
		class function Decode(Text: TStrings; Stream: TStream; Progress: TProgressCallback): String; virtual;
		class function Name: String; virtual; abstract;
	end;

	{ TMIMEDecoderList }

	TMIMEDecoderList = class(TList)
	private
		function Get(const Index: Integer): TMIMEDecoderClass;
	public
		function IndexOf(const DecoderName: String): Integer;
		property Items[const Index: Integer]: TMIMEDecoderClass read Get; default;
	end;

	{ TBase64Decoder }

	TBase64Decoder = class(TMIMEDecoder)
	public
		class function DecodeLine(const Buffer: String): String; override;
		class function Name: String; override;
	end;

	{ TUUDecoder }

	TUUDecoder = class(TMIMEDecoder)
	public
		class function DecodeLine(const Buffer: String): String; override;
		class function Name: String; override;
	end;

	{ TISO8859_1Decoder }

	TISO8859_1Decoder = class(TMIMEDecoder)
	public
		class function DecodeLine(const Buffer: String): String; override;
		class function Decode(Text: TStrings; Stream: TStream; Progress: TProgressCallback): String; override;
		class function Name: String; override;
	end;

	{ TQuotedPrintableDecoder }

	TQuotedPrintableDecoder = class(TISO8859_1Decoder)
	public
		class function Name: String; override;
	end;

	{ TWindows1252 }

	TWindows1252 = class(TISO8859_1Decoder)
	public
		class function Name: String; override;
	end;

	{ TDefaultDecoder }

	TDefaultDecoder = class(TMIMEDecoder)
	public
		class function DecodeLine(const Buffer: String): String; override;
		class function Name: String; override;
	end;

	TWriteDataEvent = procedure(Sender: TObject; Buffer: PChar; const Count: Integer) of object;
	TReadDataEvent = procedure(Sender: TObject; var Buffer: PChar; var Count: Integer) of object;
	TNoParamProc = procedure of object;
	TDecoderNameEvent = procedure(Sender: TObject; const DecoderName: String) of object;
	TProgressEvent = procedure(Sender: TObject; const Kind: TProgressKind; const Percent: Integer) of object;

	TPop3State = (
		psNone,
		psReady,
		psUserName,
		psPassword,
		psState,
		psQuit,
		psMessageList,
		psRetrieveHeader,
		psRetrieveMessage,
		psRetrieveUIDL,
		psDeleteMessage);

	TPop3PendingCall = (
		pcNone,
		pcRetrieveAllHeaders,
		pcRetrieveAllMessages,
		pcDeleteAllMessages);

	TPop3ErrorKind = (
		ekUserName,
		ekPassword,
		ekRetrieveHeader,
		ekRetrieveMessage,
		ekRetrieveUIDL,
		ekDeleteMessage,
		ekQuit,
		ekMailDropInfo,
		ekMessageList);

	TPop3AbortKind = (
		akRetrieveAllHeaders,
		akRetrieveAllMessages,
		akRetrieveAllUIDLs,
		akDeleteAllMessages);

	TPop3AcceptKind = (
		akUserName,
		akPassword);

	TPop3Step = (
		stConnect,
		stLogin,
		stState,
		stQuit,
		stLogout,
		stDelete,
		stDeleteAll,
		stList,
		stHeader,
		stAllHeaders,
		stMessage,
		stAllMessages,
		stUIDL,
		stAllUIDLs);
		
	TPop3Steps = set of TPop3Step;

	TPop3ErrorEvent = procedure(Sender: TObject; const Error: TPop3ErrorKind) of object;
	TPop3AbortEvent = procedure(Sender: TObject; const Abort: TPop3AbortKind) of object;
	TPop3AcceptEvent = procedure(Sender: TObject; const Accept: TPop3AcceptKind) of object;

	{ TWirelessPOP3

		procedure ReadData(Buffer: PChar; const Count: Integer);
		envia al componente un buffer de caracteres para procesar

		procedure ResetAll(const Force: Boolean);
		reiniciliza el componente (solo en caso de corte de comunicacion)

		procedure Login;
		envia al servidor POP3 el nombre y la clave

		procedure Logout;
		envia al servidor POP3 el pedido de desconexion

		procedure RetrieveHeader(const MessageNumber: Integer);
		pide al servidor POP3 la cabecera de un mensaje

		procedure RetrieveMessage(const MessageNumber: Integer);
		pide al servidor POP3 un mensaje

		procedure RetrieveUIDL(const MessageNumber: Integer);
		pide al servidor POP3 la UIDL de un mensaje

		procedure DeleteMessage(const MessageNumber: Integer);
		pide al servidor POP3 que marque como borrado un mensaje

		procedure RetrieveAllHeaders;
		pide al servidor POP3 la cabecera de todos los mensajes

		procedure RetrieveAllMessages;
		pide al servidor POP3 todos los mensajes

		procedure RetrieveAllUIDLs;
		pide al servidor POP3 todas UIDLs de los mensajes

		procedure DeleteAllMessages;
		pide al servidor POP3 que marque como borrado todos los mensajes

		procedure RetrieveMessageList;
		pide al servidor POP3 la lista de mensajes

		procedure RetrieveMailDropInfo;
		pide al servidor POP3 la cantidad de mensajes y el tamao

		property MessageList: TMailMessageList;
		contiene la lista de mensajes bajados

		property Decoders: TMIMEDecoderList;
		contiene la lista de decodificadores instalados

		property IsLogged: Boolean;
		contiene 'True' si esta 'logeado'

		property MessageCount: Integer;
		contiene la cantidad de mensajes que hay en el servidor POP3

		property TotalSize: Integer;
		contiene el tamao total en bytes que hay en el servidor POP3

		property UserName: String;
		contiene el nombre del usuario de la cuenta de mail

		property Password: String;
		contiene la clave del usuario de la cuenta de mail

		property OnHostGreetings: TNotifyEvent;
		se dispara al recibir la seal de 'listo' del servidor POP3

		property OnLogin: TNotifyEvent;
		se dispara al 'logearse'

		property OnLogout: TNotifyEvent;
		se dispara al 'deslogearse'

		property OnWriteData: TWriteDataEvent;
		se dispara cuando el componente necesita enviar algo al servidor POP3
	}

	TWirelessPOP3 = class(TComponent)
	private
		FState: TPop3State;
		FPendingCall: TPop3PendingCall;
		FProcessAll: Boolean;
		FResponseLine: Boolean;
		FMessageNumber: Integer;
		FTrackingHeader: Boolean;
		FSomethingReaded: Boolean;
		FLine: String;
		FRetrieved: Integer;
		FSeekLabels: Boolean;
		FInBoundary: Boolean;

		FDecoders: TMIMEDecoderList;

		FMailPart: TMailPart;
		FCurrLabel: TMIMELabel;
		FBoundary: TStringList;
		FMessageList: TMailMessageList;
		FStoreRawData: Boolean;

		FUserName: String;
		FPassword: String;
		FIsLogged: Boolean;
		FMessageCount: Integer;
		FTotalSize: Integer;

		FOnHostGreetings: TNotifyEvent;
		FOnLogin: TNotifyEvent;
		FOnLogout: TNotifyEvent;
		FOnWriteData: TWriteDataEvent;
		FOnBlockingRead: TReadDataEvent;
		FSteps: TPop3Steps;
		FErrorReceived: Boolean;

		FOnError: TPop3ErrorEvent;
		FOnAbort: TPop3AbortEvent;
		FOnAccept: TPop3AcceptEvent;

		FOnRetrieveHeader: TNotifyEvent;
		FOnRetrieveMessage: TNotifyEvent;
		FOnRetrieveUIDL: TNotifyEvent;
		FOnDeleteMessage: TNotifyEvent;
		FOnQuit: TNotifyEvent;
		FOnMailDropInfo: TNotifyEvent;
		FOnMessageList: TNotifyEvent;
		FOnRetrieveAllHeaders: TNotifyEvent;
		FOnRetrieveAllMessages: TNotifyEvent;
		FOnRetrieveAllUIDLs: TNotifyEvent;
		FOnDeleteAllMessages: TNotifyEvent;

		FOnProgress: TProgressEvent;
		FOnUnknownDecoder: TDecoderNameEvent;

		function InternalGetMessage(const MessageNumber: Integer): TMailMessage;
		procedure InternalWriteBuffer(const Buffer: String);
		procedure InternalSendUserName;
		procedure InternalSendPassword;
		procedure InternalPrepare(const MessageNumber: Integer; const State: TPop3State);
		procedure InternalRetrieveHeader(const MessageNumber: Integer);
		procedure InternalRetrieveMessage(const MessageNumber: Integer);
		procedure InternalDeleteMessage(const MessageNumber: Integer);
		procedure InternalRetrieveUIDL(const MessageNumber: Integer);
		procedure InternalMessageListProc;
		procedure InternalRetrieveHeaderProc;
		procedure InternalRetrieveMessageProc;
		procedure InternalRetrieveUIDLProc;
		procedure InternalBodyProc(MailMsj: TMailMessage);
		procedure InternalExamine(Buffer: PChar; const Count: Integer; CallerProc: TNoParamProc);

		procedure InternalCheckPendingCall;
		function InternalCheckMessageCount(const PendingCall: TPop3PendingCall): Boolean;

		procedure DoError(const Kind: TPop3ErrorKind; const CheckPending: Boolean);
		procedure DoAbort(const Kind: TPop3AbortKind);
		procedure DoAccept(const Kind: TPop3AcceptKind; const State: TPop3State);
		procedure DoEvent(const Event: TNotifyEvent; const State: TPop3State; const Step: TPop3Step; const CheckPending: Boolean);
		procedure DoProgress(const Size, Current: Integer; const Kind: TProgressKind);
		procedure DoUnknownDecoder(const DecoderName: String);
    procedure DoWaitFor(const Step: TPop3Step);
    procedure DoBlockingRead(var Buffer: PChar; var Count: Integer);
	public
		constructor Create(AOwner: TComponent); override;
		destructor Destroy; override;

		procedure ReadData(Buffer: PChar; const Count: Integer);
		procedure ResetAll(const Force: Boolean);

		procedure Login;
		procedure Logout;

		procedure RetrieveHeader(const MessageNumber: Integer);
		procedure RetrieveMessage(const MessageNumber: Integer);
		procedure RetrieveUIDL(const MessageNumber: Integer);
		procedure DeleteMessage(const MessageNumber: Integer);

		procedure RetrieveAllHeaders;
		procedure RetrieveAllMessages;
		procedure RetrieveAllUIDLs;
		procedure DeleteAllMessages;

		procedure RetrieveMessageList;
		procedure RetrieveMailDropInfo;

		function MessageByNumber(const MessageNumber: Integer): TMailMessage;
		function CurrentMessage: TMailMessage;

		property MessageList: TMailMessageList read FMessageList;
		property Decoders: TMIMEDecoderList read FDecoders;

		property IsLogged: Boolean read FIsLogged;
		property MessageCount: Integer read FMessageCount;
		property TotalSize: Integer read FTotalSize;
		property State: TPop3State read FState;
	published
		property UserName: String read FUserName write FUserName;
		property Password: String read FPassword write FPassword;
		property StoreRawData: Boolean read FStoreRawData write FStoreRawData;

		property OnHostGreetings: TNotifyEvent read FOnHostGreetings write FOnHostGreetings;
		property OnLogin: TNotifyEvent read FOnLogin write FOnLogin;
		property OnLogout: TNotifyEvent read FOnLogout write FOnLogout;
		property OnWriteData: TWriteDataEvent read FOnWriteData write FOnWriteData;
		property OnBlockingRead: TReadDataEvent read FOnBlockingRead write FOnBlockingRead;

		property OnError: TPop3ErrorEvent read FOnError write FOnError;
		property OnAbort: TPop3AbortEvent read FOnAbort write FOnAbort;
		property OnAccept: TPop3AcceptEvent read FOnAccept write FOnAccept;
		property OnProgress: TProgressEvent read FOnProgress write FOnProgress;
		property OnUnknownDecoder: TDecoderNameEvent read FOnUnknownDecoder write FOnUnknownDecoder;

		property OnRetrieveHeader: TNotifyEvent read FOnRetrieveHeader write FOnRetrieveHeader;
		property OnRetrieveMessage: TNotifyEvent read FOnRetrieveMessage write FOnRetrieveMessage;
		property OnDeleteMessage: TNotifyEvent read FOnDeleteMessage write FOnDeleteMessage;
		property OnRetrieveUIDL: TNotifyEvent read FOnRetrieveUIDL write FOnRetrieveUIDL;
		property OnQuit: TNotifyEvent read FOnQuit write FOnQuit;
		property OnMailDropInfo: TNotifyEvent read FOnMailDropInfo write FOnMailDropInfo;
		property OnMessageList: TNotifyEvent read FOnMessageList write FOnMessageList;
		property OnRetrieveAllHeaders: TNotifyEvent read FOnRetrieveAllHeaders write FOnRetrieveAllHeaders;
		property OnRetrieveAllMessages: TNotifyEvent read FOnRetrieveAllMessages write FOnRetrieveAllMessages;
		property OnRetrieveAllUIDLs: TNotifyEvent read FOnRetrieveAllUIDLs write FOnRetrieveAllUIDLs;
		property OnDeleteAllMessages: TNotifyEvent read FOnDeleteAllMessages write FOnDeleteAllMessages;
	end;

function f_MailDateToDateTime(DateStr: String): TDateTime;
function f_Pos(const Substr, Buffer: String; const Init: Integer): Integer;
function f_TokenAt(const Buffer, Separator: String; var Position: Integer): String;
function f_Compare(const Buffer, Compare: String): Boolean;
procedure f_ExtractParams(const Buffer: String; var Number: Integer; var Size: String; const CheckInt: Boolean);

procedure Register;

implementation

const
	sMessageFormatError = 'Error in Message Format';

procedure Register;
begin
	// you'd like to change it
	RegisterComponents('Mariano', [TWirelessPOP3]);
end;

{ tool functions }

// converts mail date format to delphi date format
function f_MailDateToDateTime(DateStr: String): TDateTime;

	function p_FindMonth(const Month: String): Integer;
	const
		AMonthNames: array[1..12] of String = (
			'Jan', 'Feb', 'Mar', 'Apr', 	// delphi's ShortMonthNames
			'May', 'Jun', 'Jul', 'Aug',   // changes with window's language
			'Sep', 'Oct', 'Nov', 'Dic');
	var
		i: Integer;
	begin
		for i := 1 to High(AMonthNames) do
			if f_Compare(Month, AMonthNames[i]) then
			begin
				Result := i;
				Exit;
			end;

		Result := -1;
	end;

	function p_TimeOffset(Offset: String): TDateTime;
	var
		i, iNeg: Integer;
	begin
		while true do
		begin
			i := Pos(#34, Offset);
			if i = 0 then i := Pos(#39, Offset);
			if i = 0 then Break;
			Delete(Offset, i, 1);
		end;

		if Length(Offset) < 5 then {1.5.4}
		begin
			Result := 0;
			Exit;
		end;

		if Offset[1] = '-' then
			iNeg := 1 else
			iNeg := -1;

		try
			Result := EncodeTime(
				StrToInt(Copy(Offset, 2, 2)),
				StrToInt(Copy(Offset, 4, 2)), 0, 0) * iNeg;
		except
			Result := 0;
		end;
	end;

var
	i, iCount: Integer;
	List: array[0..5] of String;
	wYear: Word;
	lpZone: TTimeZoneInformation;
begin
	Result := 0;
	DateStr := Trim(DateStr);

	if (Length(DateStr) > 0) and (DateStr[1] in ['0'..'9']) then
	begin
		i := Pos('/', DateStr);
		if i > 0 then
			try
				Result := EncodeDate(
					StrToIntDef(Copy(DateStr, i + 4, 4), 0),
					StrToIntDef(Copy(DateStr, i - 2, 2), 0),
					StrToIntDef(Copy(DateStr, i + 1, 2), 0));
			except end;

		i := Pos(':', DateStr);
		if i > 0 then
			try
				Result := Result + EncodeTime(
					StrToIntDef(Copy(DateStr, i - 2, 2), 0),
					StrToIntDef(Copy(DateStr, i + 1, 2), 0),
					StrToIntDef(Copy(DateStr, i + 4, 2), 0), 0);
			except end;

		Exit;
	end;

	i := Pos(' ', DateStr);
	if i = 0 then Exit;

	Delete(DateStr, 1, i);
	DateStr := Trimleft(DateStr);
	i := 1;
	iCount := 0;

	repeat
		if iCount > High(List) then Break; {1.6.1}
		List[iCount] := f_TokenAt(DateStr, ' ', i);
		Inc(iCount);
	until i = 0;

	GetTimeZoneInformation(lpZone); {1.6.1}

	try
		wYear := StrToInt(List[2]);
		if wYear < 1970 then Inc(wYear, 1900);
		Result :=
			EncodeDate(wYear, p_FindMonth(List[1]), StrToInt(List[0])) +
			StrToTime(List[3]) + p_TimeOffset(List[4]) - (lpZone.Bias / 24 / 60); {1.6.1}
	except
		Result := 0;
	end;
end;

// like Pos() plus initial position
function f_Pos(const Substr, Buffer: String; const Init: Integer): Integer;
begin
	if (Length(Buffer) < Init) or (Init < 1) then
		Result := 0 else
	begin
		Result := Pos(Substr, PChar(Buffer) + Init - 1);
		if (Result > 0) then Inc(Result, Init - 1);
	end;
end;

// seeks a substring delimited from init position
function f_TokenAt(const Buffer, Separator: String; var Position: Integer): String;
var
	sSub: String;
	iOld: Integer;
begin
	if (Position > Length(Buffer)) or (Length(Buffer) = 0) or (Length(Separator) = 0)then
	begin
		Position := 0;
		Result := '';
		Exit;
	end;

	if Position < 1 then Position := 1;

	iOld := Position;
	sSub := PChar(Buffer) + (Position - 1);
	Position := Pos(Separator, sSub);

	if (Position <> 0) then
	begin
		SetLength(Result, Position - 1);
		Move(sSub[1], Result[1], Position - 1);
		Inc(Position, iOld + Length(Separator) - 1);
	end else
		Result := sSub;
end;

// compares the first n chars from two strings,
// where n is the length of the shortest string
function f_Compare(const Buffer, Compare: String): Boolean;
var
	wBuf, wCom: Word;
begin
	wBuf := Length(Buffer);
	wCom := Length(Compare);

	if (wBuf = 0) or (wCom = 0) then
		Result := wBuf + wCom = 0 else
	if wBuf < wCom then
		Result := (StrLIComp(PChar(Buffer), PChar(Compare), wBuf) = 0) else
		Result := (StrLIComp(PChar(Buffer), PChar(Compare), wCom) = 0);
end;

// extracts two params from a string (ej: '1 300')
procedure f_ExtractParams(const Buffer: String; var Number: Integer; var Size: String; const CheckInt: Boolean);
var
	i: Integer;
begin
	i := Pos(#32, Buffer);

	if i > 0 then
	begin
		Number := StrToIntDef(Copy(Buffer, 1, i - 1), -1);
		Size := Trim(Copy(Buffer, i + 1, Length(Buffer)));

		if CheckInt then
			for i := 1 to Length(Size) do
				if (Size[i] < '0') or (Size[i] > '9') then
				begin
					SetLength(Size, i - 1);
					Break;
				end;

	end else
	begin
		Number := StrToIntDef(Buffer, -1);
		Size := '';
	end;
end;

{ TMIMELabel }

destructor TMIMELabel.Destroy;
begin
	if FValue <> nil then FValue.Free;
	if FParameters <> nil then FParameters.Free;
	inherited Destroy;
end;

// a parameter is a label's modificator.
// ej: Content-Type: text/plain; charset="iso-8859-1"
// here 'charset' is the parameter and "iso-8859-1" is the value
function TMIMELabel.AddParameter(const Name, Value: String): String;
var
	iPos: Integer;
	sName, sValue: String;
begin
	sName := Trim(Name);
	sValue := Trim(Value);

	if Length(sValue) > 0 then
	begin
		if sValue[1] = #34 then
		begin
			System.Delete(sValue, 1, 1);
			iPos := Pos(#34, sValue);
			if iPos > 0 then SetLength(sValue, iPos - 1);
		end else
		if sValue[Length(sValue)] = ';' then
			SetLength(sValue, Length(sValue) - 1);
	end;

	Result := sName + '=' + sValue;
	if FParameters = nil then FParameters := TStringList.Create;
	FParameters.Add(Result);
end;

function TMIMELabel.GetParameter(const Name: String): String;
var
	i: Integer;
	sName: String;
begin
	sName := Name + '=';
	
	if FParameters <> nil then
		for i := 0 to FParameters.Count - 1 do
			if f_Compare(FParameters[i], sName) then
			begin
				Result := Copy(FParameters[i], Length(sName) + 1, Length(FParameters[i]));
				Exit;
			end;

	Result := '';
end;

procedure TMIMELabel.AddValue(const Value: String);
var
	i, iPos: Integer;
	sValue, sItem: String;
begin
	sValue := Trim(Value);
	i := 1;

	repeat
		sItem := f_TokenAt(sValue, ';', i);
		if Length(sItem) = 0 then Break;
		iPos := Pos('=', sItem);

		if (FValue <> nil) and (iPos > 1) then
			AddParameter(Copy(sItem, 1, iPos - 1), Copy(sItem, iPos + 1, Length(sItem))) else
		begin
			if FValue = nil then FValue := TStringList.Create;
			FValue.Add(Trim(sItem));
		end;
	until i = 0;
end;

{ TMIMELabelList }

destructor TMIMELabelList.Destroy;
var
	i: Integer;
begin
	for i := 0 to Count - 1 do
		Items[i].Free;

	inherited Destroy;
end;

function TMIMELabelList.Get(const Index: Integer): TMIMELabel;
begin
	Result := inherited Items[Index];
end;

function TMIMELabelList.AddLabel(const Name: String): TMIMELabel;
begin
	Result := TMimeLabel.Create;
	Result.FName := Name;
	Add(Result);
end;

function TMIMELabelList.GetLabel(const Name: String): TMIMELabel;
var
	i: Integer;
begin
	for i := 0 to Count - 1 do
		if StrIComp(PChar(Items[i].FName), PChar(Name)) = 0 then
		begin
			Result := Items[i];
			Exit;
		end;

	Result := nil;
end;

{ TMailPartList }

destructor TMailPartList.Destroy;
var
	i: Integer;
begin
	for i := 0 to Count - 1 do
		Items[i].Free;

	inherited Destroy;
end;

procedure TMailPartList.ClearList;
var
	i: Integer;
begin
	for i := 0 to Count - 1 do
		Items[i].Free;

	Clear;
end;

function TMailPartList.Get(const Index: Integer): TMailPart;
begin
	Result := inherited Items[Index];
end;

function TMailPartList.Last: TMailPart;
begin
	Result := inherited Items[Count - 1];
end;

{ TMailPart }

constructor TMailPart.Create;
begin
	FMIMELabels := TMIMELabelList.Create;
	FBody := TStringList.Create;
	inherited Create;
end;

destructor TMailPart.Destroy;
begin
	FMIMELabels.Free;
	FBody.Free;
	inherited Destroy;
end;

function TMailPart.GetContentInfo(var Info: TMIMEContentInfo): Boolean;
var
	i: Integer;
	mLabel: TMIMELabel;
begin
	FillChar(Info, SizeOf(TMIMEContentInfo), 0);

	mLabel := FMIMELabels.GetLabel('Content-Type');
	if (mLabel <> nil) and (mLabel.FValue.Count > 0) then
	begin
		Info.ContentType := mLabel.FValue[0];
		Info.Name := mLabel.GetParameter('name');
		Info.Charset := mLabel.GetParameter('charset');

		if Length(Info.Charset) > 0 then
			i := FMailMessage.FOwner.FDecoders.IndexOf(Info.Charset) else
			i := -2;	// means no charset

		if i >= 0 then
			Info.CharsetDecoder := FMailMessage.FOwner.FDecoders[i] else
		if i = -1 then // means not found
			Info.CharsetDecoder := TDefaultDecoder else
			Info.CharsetDecoder := nil
	end;

	mLabel := FMIMELabels.GetLabel('Content-ID');
	if (mLabel <> nil) and (mLabel.FValue.Count > 0) then Info.ContentID := mLabel.FValue[0];

	mLabel := FMIMELabels.GetLabel('Content-Transfer-Encoding');
	if (mLabel <> nil) and (mLabel.FValue.Count > 0) then
	begin
		Info.TransferEncoding := mLabel.FValue[0];

		if Length(Info.TransferEncoding) > 0 then
			i := FMailMessage.FOwner.FDecoders.IndexOf(Info.TransferEncoding) else
			i := -1;

		if i >= 0 then
			Info.TransferDecoder := FMailMessage.FOwner.FDecoders[i] else
		if i = -1 then
			Info.TransferDecoder := TDefaultDecoder else
			Info.TransferDecoder := nil;
	end;

	mLabel := FMIMELabels.GetLabel('Content-Disposition');
	if (mLabel <> nil) and (mLabel.FValue.Count > 0) then
	begin
		Info.Disposition := mLabel.FValue[0];
		Info.FileName := mLabel.GetParameter('filename');
	end;

	Info.Body := FBody;
	Result := true;
end;

{ TMailMessage }

constructor TMailMessage.Create;
begin
	inherited Create;
	FSize := -1;
	FMailParts := TMailPartList.Create;
	FRawData := TStringList.Create;
end;

destructor TMailMessage.Destroy;
begin
	FMailParts.Free;
	FRawData.Free;
	inherited Destroy;
end;

function TMailMessage.GetLabel(const Name: String): String;
var
	i, j, iFound, q, iBeg, iEnd: Integer;
	sTemp: String;
begin
	Result := '';

	if FMailParts.Count > 0 then
		with FMailParts.Items[0] do // Items[0] is the mail header
			for i := 0 to FMIMELabels.Count - 1 do
				if AnsiCompareText(FMIMELabels.Items[i].FName, Name) = 0 then
				begin
					if FMIMELabels.Items[i].FValue <> nil then
					begin
						q := FMIMELabels.Items[i].FValue.Count - 1;

						for j := 0 to q do
							if (j < q) or (Length(FMIMELabels.Items[i].FValue[j]) > 0) then
								if j = 0 then
									Result := Result + FMIMELabels.Items[i].FValue[j] else
									Result := Result + ' ' + FMIMELabels.Items[i].FValue[j];
					end;
					
					Break;
				end; {if}

	if (Length(Result) > 0) then
	begin
		while true do
		begin
			iBeg := Pos('=?', Result);	// search charset notation on label text

			if iBeg > 0 then
			begin
				iEnd := Pos('?=', Result);
				iFound := 0;

				if iEnd > 0 then
					for i := 0 to FOwner.FDecoders.Count - 1 do
					begin
						iFound := Pos(FOwner.FDecoders[i].Name, LowerCase(Result));

						if iFound > 0 then
						begin
							sTemp := Copy(Result, 1, iEnd - 1);
							sTemp := Copy(sTemp, iFound + Length(FOwner.FDecoders[i].Name) + 3, Length(sTemp));
							sTemp := FOwner.FDecoders[i].DecodeLine(sTemp);

							for j := 1 to Length(sTemp) do
								if sTemp[j] = '_' then sTemp[j] := #32;

							Result := Copy(Result, 1, iBeg - 1) + sTemp + Copy(Result, iEnd + 2, Length(Result));
							Break; {for}
						end; {if}
					end; {for}

				if iFound > 0 then Continue;
			end; {if}

			Break;
		end; {while}
	end; {if}
end;

function TMailMessage.GetMainText: String;
var
	Info: TMIMEContentInfo;
	i: Integer;
	Stream: TStringStream;
begin
	Result := '';

	for i := 0 to FMailParts.Count - 1 do
		if FMailParts[i].GetContentInfo(Info) and
			f_Compare(Info.ContentType, 'text/') then
		begin
			if Info.CharsetDecoder <> nil then // if the text has a known decoder
			begin
				Stream := TStringStream.Create('');
				try
					Info.CharsetDecoder.Decode(Info.Body, Stream, FOwner.DoProgress);	// decode it
					SetLength(Result, Stream.Size);
					Stream.Seek(0, 0); // position at first
					Stream.Read(Result[1], Length(Result)); // copy it to 'Result'
				finally
					Stream.Free;
				end;
			end else
			begin	// remember you can add new decoders (TMIMEDecoder descendant)
				FOwner.DoUnknownDecoder(Info.Charset);
				Result := Info.Body.Text; // return the text 'as is' (sometimes unreadable)
			end;
			Break;
		end;

	// if no 'Content-Type: text/..' found and the first MailPart has text
	if (Length(Result) = 0) and (FMailParts.Count > 0) and
		FMailParts[0].GetContentInfo(Info) and
		(Info.Body <> nil) and (Info.Body.Count > 0) then
		Result := Info.Body.Text;

	Result := Trim(Result);
end;

function TMailMessage.GetAttachedList(List: TStrings): Boolean;
var
	i: Integer;
	Info: TMIMEContentInfo;
begin
	if List <> nil then
	begin
		List.Clear;

		for i := 0 to FMailParts.Count - 1 do
			if FMailParts[i].GetContentInfo(Info) and (Length(Info.FileName) > 0) then
				List.Add(Info.FileName);

		Result := List.Count > 0;
	end else
		Result := false;
end;

function TMailMessage.GetAttachedNames: String;
var
	i: Integer;
	Info: TMIMEContentInfo;
begin
	Result := '';

	for i := 0 to FMailParts.Count - 1 do
		if FMailParts[i].GetContentInfo(Info) and (Length(Info.FileName) > 0) then
			if i < FMailParts.Count - 2 then
				Result := Result + Info.FileName + ', ' else
				Result := Result + Info.FileName;
end;

function TMailMessage.GetAttachedCount: Integer;
var
	i: Integer;
	Info: TMIMEContentInfo;
begin
	Result := 0;

	for i := 0 to FMailParts.Count - 1 do
		if FMailParts[i].GetContentInfo(Info) and (Length(Info.FileName) > 0) then
			Inc(Result);
end;

function TMailMessage.SaveAttachedToStream(const FileName: String; Stream: TStream): Boolean;
var
	i: Integer;
	Info: TMIMEContentInfo;
begin
	Result := false;

	for i := 0 to FMailParts.Count - 1 do
		if FMailParts[i].GetContentInfo(Info) and
			(AnsiCompareText(FileName, Info.FileName) = 0) then
		begin
			if Info.CharsetDecoder <> nil then
				Info.CharsetDecoder.Decode(Info.Body, Stream, FOwner.DoProgress) else
			if Info.TransferDecoder <> nil then
			begin
				Info.TransferDecoder.Decode(Info.Body, Stream, FOwner.DoProgress);
				Result := true;
			end else
			begin
				FMailParts[i].FMailMessage.FOwner.DoUnknownDecoder(Info.TransferEncoding);
				TDefaultDecoder.Decode(Info.Body, Stream, FOwner.DoProgress);
			end;

			Break;
		end;
end;

function TMailMessage.SaveAttachedToFile(const AttachedFileName, DiskFileName: String): Boolean;
var
	Stream: TFileStream;
	sFileName: String;
begin
	if Length(DiskFileName) = 0 then
		sFileName := AttachedFileName else
		sFileName := DiskFileName;

	Stream := TFileStream.Create(sFileName, fmCreate);

	try
		Result := SaveAttachedToStream(AttachedFileName, Stream);
	finally
		Stream.Free;
	end;
end;

{ TMailMessageList }

procedure TMailMessageList.ClearList;
var
	i: Integer;
begin
	for i := 0 to Count - 1 do // does not reset 'Count'
		Items[i].Free;

	Clear; {1.1.1} // this set 'Count' to 0
end;

destructor TMailMessageList.Destroy;
begin
	ClearList;
	inherited Destroy;
end;

function TMailMessageList.Get(const Index: Integer): TMailMessage;
begin
	Result := inherited Items[Index];
end;

{ TMIMEDecoder }

class function TMIMEDecoder.Decode(Text: TStrings; Stream: TStream; Progress: TProgressCallback): String;
var
	i, iCount, iCurr, iFreq: Integer;
	sLine: String;
begin
	iCurr := 0;
	iCount := Text.Count;
	iFreq := iCount div 100;
	Progress(iCount, iCurr, pkDecode);

	for i := 0 to iCount - 1 do
	begin
		sLine := DecodeLine(Text[i]);	// decode each line
		if Length(sLine) > 0 then Stream.Write(sLine[1], Length(sLine));
		Inc(iCurr);
		if (iFreq > 0) and (iCurr mod iFreq = 0) then Progress(iCount, iCurr, pkDecode);
	end;

	Progress(1, 1, pkDecode); // ensure 100%
end;

{ TMIMEDecoderList }

function TMIMEDecoderList.Get(const Index: Integer): TMIMEDecoderClass;
begin
	Result := inherited Items[Index];
end;

function TMIMEDecoderList.IndexOf(const DecoderName: String): Integer;
var
	i: Integer;
begin
	for i := 0 to Count - 1 do
		if AnsiCompareText(Items[i].Name, DecoderName) = 0 then
		begin
			Result := i;
			Exit;
		end;

	Result := -1;
end;

{ TBase64Decoder }

class function TBase64Decoder.DecodeLine(const Buffer: String): String;
var
	Byte4: array[1..4] of Byte;
	Byte3: array[1..3] of Byte;
	i, iCount, iIdx, iLen: Integer;
begin
	Result := '';
	iIdx := 0;

	for i := 1 to Length(Buffer) do
	begin
		Inc(iIdx);

		case Buffer[i] of
			'A'..'Z': Byte4[iIdx] := Ord(Buffer[i]) - 65;
			'a'..'z': Byte4[iIdx] := Ord(Buffer[i]) - 71;
			'0'..'9': Byte4[iIdx] := Ord(Buffer[i]) + 4;
			'+': 			Byte4[iIdx] := 62;
			'/': 			Byte4[iIdx] := 63;
			'=': 			Byte4[iIdx] := 64;
		end;

		if iIdx = 4 then
		begin
			iIdx := 0;

			if Byte4[1] = 64 then
				iCount := 0 else
				iCount := 3;

			if Byte4[3] = 64 then
			begin
				Byte4[3] := 0;
				Byte4[4] := 0;
				iCount := 1;
			end;

			if Byte4[4] = 64 then
			begin
				Byte4[4] := 0;
				iCount := 2;
			end;

			Byte3[1] := Byte4[1] * 4 + (Byte4[2] div 16);
			Byte3[2] := (Byte4[2] mod 16) * 16 + (Byte4[3] div 4);
			Byte3[3] := (Byte4[3] mod 4) * 64 + Byte4[4];

			iLen := Length(Result);
			SetLength(Result, iLen + iCount);
			Move(Byte3, Result[iLen + 1], iCount);
		end;
	end;
end;

class function TBase64Decoder.Name: String;
begin
	Result := 'base64';
end;

{ TUUDecoder }

class function TUUDecoder.DecodeLine(const Buffer: String): String;
const
	CHARS_PER_LINE = 45;
	Table = '`!"#$%&''()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_';
var
	A24Bits: array[0..8 * CHARS_PER_LINE] of Boolean;
	i, j, k, b: Word;
	LineLen, ActualLen: Byte;

	function p_ByteFromTable(Ch: Char): Byte;
	var
		i: Integer;
	begin
		i := 1;

		while (Ch <> Table[i]) and (i <= 64) do
			Inc(i);

		if i > 64 then
		begin
			if Ch = #32 then
				Result := 0 else
				raise Exception.Create(sMessageFormatError);
		end else
			Result := i - 1;
	end;

begin
	if f_Compare(Buffer, 'begin') or f_Compare(Buffer, 'end') then
	begin
		Result := '';	{1.2.2}
		Exit;
	end;

	LineLen := p_ByteFromTable(Buffer[1]);
	ActualLen := 4 * LineLen div 3;

	FillChar(A24Bits, 8 * CHARS_PER_LINE + 1, 0);
	SetLength(Result, LineLen);

	if ActualLen <> (4 * CHARS_PER_LINE div 3) then
		ActualLen := Length(Buffer) - 1;

	k := 0;
	for i := 2 to ActualLen + 1 do
	begin
		b := p_ByteFromTable(Buffer[i]);
		for j := 5 downto 0 do
		begin
			A24Bits[k] := b and (1 shl j) > 0;
			Inc(k);
		end;
	end;

	k := 0;
	for i := 1 to CHARS_PER_LINE do
	begin
		b := 0;
		for j := 7 downto 0 do
		begin
			if A24Bits[k] then b := b or (1 shl j);
			Inc(k);
		end;
		Result[i] := Char(b);
	end;
end;

class function TUUDecoder.Name: String;
begin
	Result := 'uuencode';
end;

{ TISO8859_1Decoder }

class function TISO8859_1Decoder.DecodeLine(const Buffer: String): String;
const
	sChars: String = '0123456789ABCDEF';
var
	i, iIdx, iAnt, iPos: Integer;
begin
	iIdx := 1;
	iAnt := 1;

	SetLength(Result, Length(Buffer));
	FillChar(Result[1], Length(Buffer), 0);

	repeat
		iPos := f_Pos('=', Buffer, iAnt);

		if iPos > 0 then
		begin
			if (iPos > iAnt) then
			begin
				Move(Buffer[iAnt], Result[iIdx], iPos - iAnt);
				Inc(iIdx, iPos - iAnt);
			end;

			if iPos < Length(Buffer) - 1 then
			begin
				if (Pos(Buffer[iPos + 1], sChars) > 0) and (Pos(Buffer[iPos + 2], sChars) > 0) then
				begin
					Result[iIdx] := Char(StrToIntDef('$' + Buffer[iPos + 1] + Buffer[iPos + 2], 32));
					Inc(iIdx);
				end;
			end else
			if iPos = Length(Buffer) then
			begin
				Result[iIdx] := #13;
				Break;
			end;

			iAnt := iPos + 3;
		end else
		begin
			iPos := Length(Buffer) - iAnt + 1;
			if iPos > 0 then Move(Buffer[iAnt], Result[iIdx], iPos);
			Break;
		end;
	until false;

	iIdx := Length(Result);

	for i := iIdx downto 1 do
		if (Result[i] > #31) or (Result[i] = #13) then
		begin
			if i < iIdx then iIdx := i;
			Break;
		end;

	if iIdx <> Length(Result) then SetLength(Result, iIdx);
end;

class function TISO8859_1Decoder.Decode(Text: TStrings; Stream: TStream; Progress: TProgressCallback): String;
var
	i, iIdx, iCount, iCurr, iFreq: Integer;
	sLine: String;
begin
	iCurr := 0;
	iCount := Text.Count;
	iFreq := iCount div 100;
	Progress(iCount, iCurr, pkDecode);

	for i := 0 to iCount - 1 do
	begin
		sLine := DecodeLine(Text[i]);
		iIdx := Length(sLine);

		if (iIdx > 0) and (sLine[iIdx] = #13) then
			SetLength(sLine, iIdx - 1) else
		if i < iCount - 1 then
		begin
			SetLength(sLine, iIdx + 2);
			sLine[iIdx + 1] := #13;
			sLine[iIdx + 2] := #10;
		end;

		if Length(sLine) > 0 then Stream.Write(sLine[1], Length(sLine));
		Inc(iCurr);
		if (iFreq > 0) and (iCurr mod iFreq = 0) then Progress(iCount, iCurr, pkDecode);
	end;

	Progress(1, 1, pkDecode); // ensure 100%
end;

class function TISO8859_1Decoder.Name: String;
begin
	Result := 'iso-8859-1';
end;

{ TQuotedPrintableDecoder }

class function TQuotedPrintableDecoder.Name: String;
begin
	Result := 'quoted-printable';
end;

{ TWindows1252 }

class function TWindows1252.Name: String;
begin
	Result := 'windows-1252';
end;

{ TDefaultDecoder }

class function TDefaultDecoder.DecodeLine(const Buffer: String): String;
begin
	Result := Buffer + #13#10;
end;

class function TDefaultDecoder.Name: String;
begin
	Result := 'default';
end;

{ TWirelessPOP3 }

constructor TWirelessPOP3.Create(AOwner: TComponent);
begin
	inherited Create(AOwner);

	FUserName := '';
	FPassword := '';
	FStoreRawData := false;

	FMessageList := TMailMessageList.Create;
	FBoundary := TStringList.Create;
	FDecoders := TMIMEDecoderList.Create;

	FDecoders.Add(TBase64Decoder); // add the decoder class name
	FDecoders.Add(TUUDecoder);     // because no need of instantiation
	FDecoders.Add(TISO8859_1Decoder);
	FDecoders.Add(TQuotedPrintableDecoder);
	FDecoders.Add(TWindows1252);
	FDecoders.Add(TDefaultDecoder);

	ResetAll(true);
end;

destructor TWirelessPOP3.Destroy;
begin
	FMessageList.Free;
	FBoundary.Free;
	FDecoders.Free;

	inherited Destroy;
end;

procedure TWirelessPOP3.ResetAll(const Force: Boolean);
begin
	// 'Force' means: 'no matter if it's logged on'
	if (not Force) and FIsLogged then Exit;

	FSteps := [];

	FMessageCount := -1;
	FTotalSize := -1;

	FState := psNone;
	FPendingCall := pcNone;

	FProcessAll := false;
	FResponseLine := false;
	FMessageNumber := -1;
	FTrackingHeader := false;
	FSomethingReaded := false;
	FIsLogged := false;

	FSeekLabels := true;
	FInBoundary := false;
	
	FMessageList.ClearList;
	FBoundary.Clear;
end;

procedure TWirelessPOP3.ReadData(Buffer: PChar; const Count: Integer);
var
	sSize: String;
begin
	case FState of
		psNone:
		begin
			if (not FIsLogged) and (StrLComp(Buffer, '+OK', 3) = 0) then
			begin
				ResetAll(true);
				DoEvent(FOnHostGreetings, psReady, stConnect, false);
			end;
		end;

		psUserName:
		begin
			if StrLComp(Buffer, '+OK', 3) = 0 then
			begin
				DoAccept(akUserName, psReady);
				InternalSendPassword;
			end else
				DoError(ekUserName, false);
		end;

		psPassword:
		begin
			if StrLComp(Buffer, '+OK', 3) = 0 then
			begin
				FIsLogged := true;
				DoAccept(akPassword, psReady);
				DoEvent(FOnLogin, psReady, stLogin, false);
			end else
				DoError(ekPassword, false);
		end;

		psState:
		begin
			if StrLComp(Buffer, '+OK', 3) = 0 then
			begin
				f_ExtractParams(Copy(Buffer, 5, Count), FMessageCount, sSize, true);
				FTotalSize := StrToIntDef(sSize, -1);
				DoEvent(FOnMailDropInfo, psReady, stState, true);
			end else
				DoError(ekMailDropInfo, true);
		end;

		psQuit:
		begin
			if StrLComp(Buffer, '+OK', 3) = 0 then
			begin
				DoEvent(FOnQuit, psReady, stQuit, false);
				if FIsLogged then
				begin
					FIsLogged := false;
					DoEvent(FOnLogout, psNone, stLogout, false);
				end else
					FState := psNone; {1.5.2}
			end else
				DoError(ekQuit, false);
		end;

		psMessageList:			InternalExamine(Buffer, Count, InternalMessageListProc);
		psRetrieveHeader:		InternalExamine(Buffer, Count, InternalRetrieveHeaderProc);
		psRetrieveMessage:	InternalExamine(Buffer, Count, InternalRetrieveMessageProc);
		psRetrieveUIDL:			InternalExamine(Buffer, Count, InternalRetrieveUIDLProc);

		psDeleteMessage:
		begin
			if StrLComp(Buffer, '+OK', 3) = 0 then
			begin
				DoEvent(FOnDeleteMessage, psReady, stDelete, true);

				if FProcessAll then
					if FMessageNumber < FMessageCount then
					begin
						if FState <> psReady then // a retrieve method was called
							FPendingCall := pcDeleteAllMessages else
							InternalDeleteMessage(FMessageNumber + 1);
					end else
						DoEvent(FOnDeleteAllMessages, FState, stDeleteAll, false);
			end else
			begin
				DoError(ekDeleteMessage, true);
				if FProcessAll then DoAbort(akDeleteAllMessages);
			end; {if}
		end;
	end; {case}
end;

procedure TWirelessPOP3.InternalExamine(Buffer: PChar; const Count: Integer; CallerProc: TNoParamProc);
var
	i: Integer;
begin
	for i := 0 to Count - 1 do
	begin
		if (Buffer[i] <> #10) and (Buffer[i] <> #13) then
			FLine := FLine + Buffer[i];

		if Buffer[i] = #13 then // only char 13 (CR) marks end of line (1.3.3)
		begin
			CallerProc;
			FLine := '';
		end;
	end;
end;

// 'Number' is the message number at pop server.
// note if you have 2 messages (at server) and retrieve the message 2 before 1,
// it comes the first message retrieved (referenced by MessageList[0], not 2!),
// so you can access it with MessageByNumber(2) to avoid confusion
function TWirelessPOP3.MessageByNumber(const MessageNumber: Integer): TMailMessage;
var
	i: Integer;
begin
	for i := 0 to FMessageList.Count - 1 do
		if FMessageList[i].FNumber = MessageNumber then
		begin
			Result := FMessageList[i];
			Exit;
		end;

	Result := nil;
end;

// returns the current incoming message
function TWirelessPOP3.CurrentMessage: TMailMessage;
begin
	Result := MessageByNumber(FMessageNumber);
end;

function TWirelessPOP3.InternalGetMessage(const MessageNumber: Integer): TMailMessage;
begin
	Result := MessageByNumber(MessageNumber);

	if Result = nil then // not exists
	begin
		Result := TMailMessage.Create; // create a new one
		Result.FOwner := Self;
		Result.FNumber := MessageNumber;
		FMessageList.Add(Result);
	end;
end;

procedure TWirelessPOP3.InternalWriteBuffer(const Buffer: String);
begin
	FLine := '';	// reset the line buffer
	FErrorReceived := false;
	if Assigned(FOnWriteData) then
		FOnWriteData(Self, PChar(Buffer + #13#10), Length(Buffer) + 2);
end;

procedure TWirelessPOP3.InternalCheckPendingCall;
begin
	case FPendingCall of
		pcNone:									Exit;
		pcRetrieveAllHeaders:		InternalRetrieveHeader(FMessageNumber + 1);
		pcRetrieveAllMessages:	InternalRetrieveMessage(FMessageNumber + 1);
		pcDeleteAllMessages:		InternalDeleteMessage(FMessageNumber + 1);
	end;

	FPendingCall := pcNone;
	FProcessAll := true;
end;

procedure TWirelessPOP3.DoError(const Kind: TPop3ErrorKind; const CheckPending: Boolean);
begin
	FState := psReady;
	FErrorReceived := true;
	if Assigned(FOnError) then FOnError(Self, Kind);
	if CheckPending then InternalCheckPendingCall;
end;

procedure TWirelessPOP3.DoAbort(const Kind: TPop3AbortKind);
begin
	if Assigned(FOnAbort) then FOnAbort(Self, Kind);
end;

procedure TWirelessPOP3.DoEvent(const Event: TNotifyEvent; const State: TPop3State; const Step: TPop3Step; const CheckPending: Boolean);
begin
	Include(FSteps, Step);
	FState := State;
	if Assigned(Event) then Event(Self);
	if CheckPending then InternalCheckPendingCall;
end;

procedure TWirelessPOP3.DoAccept(const Kind: TPop3AcceptKind; const State: TPop3State);
begin
	FState := State;
	if Assigned(FOnAccept) then FOnAccept(Self, Kind);
end;

procedure TWirelessPOP3.DoProgress(const Size, Current: Integer; const Kind: TProgressKind);
var
	iPer: Integer;
begin
	if Assigned(FOnProgress) and (Size > 0) then
	begin
		iPer := Current * 100 div Size;
		if iPer > 100 then iPer := 100;
		FOnProgress(Self, Kind, iPer);
	end;
end;

procedure TWirelessPOP3.DoUnknownDecoder(const DecoderName: String);
begin
	if Assigned(FOnUnknownDecoder) then
		FOnUnknownDecoder(Self, DecoderName);
end;

procedure TWirelessPOP3.Login;
begin
	DoWaitFor(stConnect);
	InternalSendUserName;
	DoWaitFor(stLogin);
end;

procedure TWirelessPOP3.Logout;
begin
	// quits no matter if logged on or off
	FState := psQuit;
	InternalWriteBuffer('QUIT');
	DoWaitFor(stLogout);
end;

procedure TWirelessPOP3.InternalSendUserName;
begin
	if FIsLogged then Exit;

	if Length(FUserName) > 0 then
	begin
		FState := psUserName;
		InternalWriteBuffer('USER ' + FUserName);
	end else
		DoError(ekUserName, false);
end;

procedure TWirelessPOP3.InternalSendPassword;
begin
	if FIsLogged then Exit;

	if Length(FPassword) > 0 then
	begin
		FState := psPassword;
		InternalWriteBuffer('PASS ' + FPassword);
	end else
		DoError(ekPassword, false);
end;

procedure TWirelessPOP3.RetrieveMessageList;
begin
	if not FIsLogged then Exit;

	FTotalSize := 0;
	FState := psMessageList;
	InternalWriteBuffer('LIST');
	DoWaitFor(stList);
end;

procedure TWirelessPOP3.RetrieveMailDropInfo;
begin
	if not FIsLogged then Exit;

	FState := psState;
	InternalWriteBuffer('STAT');
	DoWaitFor(stState);
end;

procedure TWirelessPOP3.InternalPrepare(const MessageNumber: Integer; const State: TPop3State);
begin
	FMessageNumber := MessageNumber;
	FState := State;
	FResponseLine := true;
	FTrackingHeader := true;
	FSomethingReaded := false;
	FSeekLabels := true;
	FMailPart := nil;
end;

procedure TWirelessPOP3.InternalRetrieveHeader(const MessageNumber: Integer);
begin
	if not FIsLogged then Exit;

	if (MessageNumber > 0) then
	begin
		InternalPrepare(MessageNumber, psRetrieveHeader);
		InternalWriteBuffer('TOP ' + IntToStr(MessageNumber) + ' 0');
	end	else
		DoError(ekRetrieveHeader, false);
end;

procedure TWirelessPOP3.InternalRetrieveMessage(const MessageNumber: Integer);
var
	MailMsg: TMailMessage;
begin
	if not FIsLogged then Exit;

	if (MessageNumber > 0) then
	begin
		MailMsg := MessageByNumber(MessageNumber);
		if MailMsg <> nil then MailMsg.FMailParts.ClearList; {1.5}

		InternalPrepare(MessageNumber, psRetrieveMessage);
		InternalWriteBuffer('RETR ' + IntToStr(MessageNumber));
	end	else
		DoError(ekRetrieveMessage, false);
end;

procedure TWirelessPOP3.InternalRetrieveUIDL(const MessageNumber: Integer);
begin
	if not FIsLogged then Exit;

	InternalPrepare(MessageNumber, psRetrieveUIDL);

	if not FProcessAll then
		InternalWriteBuffer('UIDL ' + IntToStr(MessageNumber)) else
		InternalWriteBuffer('UIDL');
end;

procedure TWirelessPOP3.InternalDeleteMessage(const MessageNumber: Integer);
begin
	if not FIsLogged then Exit;

	if (MessageNumber > 0) then
	begin
		InternalPrepare(MessageNumber, psDeleteMessage);
		InternalWriteBuffer('DELE ' + IntToStr(MessageNumber));
	end	else
		DoError(ekRetrieveMessage, false);
end;

procedure TWirelessPOP3.RetrieveHeader(const MessageNumber: Integer);
begin
	FProcessAll := false;
	InternalRetrieveHeader(MessageNumber);
	DoWaitFor(stHeader);
end;

procedure TWirelessPOP3.RetrieveMessage(const MessageNumber: Integer);
begin
	FProcessAll := false;
	InternalRetrieveMessage(MessageNumber);
	DoWaitFor(stMessage);
end;

procedure TWirelessPOP3.RetrieveUIDL(const MessageNumber: Integer);
begin
	FProcessAll := false;
	InternalRetrieveUIDL(MessageNumber);
	DoWaitFor(stUIDL);
end;

procedure TWirelessPOP3.DeleteMessage(const MessageNumber: Integer);
begin
	FProcessAll := false;
	InternalDeleteMessage(MessageNumber);
end;

function TWirelessPOP3.InternalCheckMessageCount(const PendingCall: TPop3PendingCall): Boolean;
begin
	Result := FMessageCount <> -1;

	if not Result then
	begin
		FMessageNumber := 0;
		FPendingCall := PendingCall;
		RetrieveMailDropInfo;
	end;
end;

procedure TWirelessPOP3.RetrieveAllHeaders;
begin
	FProcessAll := true;

	if InternalCheckMessageCount(pcRetrieveAllHeaders) then
		InternalRetrieveHeader(1);

	DoWaitFor(stAllHeaders);
end;

procedure TWirelessPOP3.RetrieveAllMessages;
begin
	FProcessAll := true;

	if InternalCheckMessageCount(pcRetrieveAllMessages) then
		InternalRetrieveMessage(1);

	DoWaitFor(stAllMessages);
end;

procedure TWirelessPOP3.RetrieveAllUIDLs;
begin
	FProcessAll := true;
	InternalRetrieveUIDL(1);
	DoWaitFor(stAllUIDLs);
end;

procedure TWirelessPOP3.DeleteAllMessages;
begin
	FProcessAll := true;

	if InternalCheckMessageCount(pcDeleteAllMessages) then
		InternalDeleteMessage(1);

	DoWaitFor(stDeleteAll);
end;

procedure TWirelessPOP3.InternalMessageListProc;
var
	iNumber: Integer;
	sSize: String;
begin
	if FResponseLine then // if waitting +OK or -ERR
	begin
		FResponseLine := false;
		if StrLComp(PChar(FLine), '+OK', 3) <> 0 then DoError(ekMessageList, true);
	end else
	if (FLine = '.') then
	begin
		DoEvent(FOnMessageList, psReady, stList, true);
	end else
	if (Length(FLine) > 0) and (FState = psMessageList) then // avoid trash after end
	begin
		f_ExtractParams(FLine, iNumber, sSize, true);

		if iNumber > FMessageCount then
			FMessageCount := iNumber;

		with InternalGetMessage(iNumber) do
		begin
			FSize := StrToIntDef(sSize, -1);
			Inc(Self.FTotalSize, FSize);
		end;
	end; {if}
end;

procedure TWirelessPOP3.InternalRetrieveHeaderProc;
var
	MailMsj: TMailMessage;
begin
	if FResponseLine then // if waitting +OK or -ERR
	begin
		if Length(FLine) > 0 then
		begin
			if StrLComp(PChar(FLine), '+ERR', 4) = 0 then
			begin
				DoError(ekRetrieveHeader, false); // item bad
				if FProcessAll then DoAbort(akRetrieveAllHeaders); // everything bad
			end else
			if StrLComp(PChar(FLine), '+OK', 3) = 0 then
				FResponseLine := false;
		end; {if}
	end else
	if (FLine = '.') then
	begin
		FTrackingHeader := false;
		FPendingCall := pcNone;
		DoEvent(FOnRetrieveHeader, psReady, stHeader, false); // now support retrieve method calls

		if FProcessAll then
			if FMessageNumber < FMessageCount then
			begin
				if FState <> psReady then // a retrieve method was called
					FPendingCall := pcRetrieveAllHeaders else
					InternalRetrieveHeader(FMessageNumber + 1);
			end else
				DoEvent(FOnRetrieveAllHeaders, FState, stAllHeaders, false);
	end else
	if FState = psRetrieveHeader then // avoid trash after end
	begin
		MailMsj := InternalGetMessage(FMessageNumber);
		FSomethingReaded := true;
		InternalBodyProc(MailMsj);
	end; {if}
end;

procedure TWirelessPOP3.InternalRetrieveMessageProc;
var
	MailMsj: TMailMessage;
	sTrail: String;
begin
	if FResponseLine then // if waitting +OK or -ERR
	begin
		if Length(FLine) > 0 then
		begin
			if StrLComp(PChar(FLine), '+ERR', 4) = 0 then
			begin
				DoError(ekRetrieveMessage, false); // item bad
				if FProcessAll then DoAbort(akRetrieveAllMessages); // everything bad
			end else
			if StrLComp(PChar(FLine), '+OK', 3) = 0 then
			begin
				FResponseLine := false;

				with InternalGetMessage(FMessageNumber) do
				begin
					if FSize = -1 then // can be set by LIST
						f_ExtractParams(Copy(FLine, 5, Length(FLine)), FSize, sTrail, true);

					FRetrieved := 0; // reset counter
					DoProgress(FSize, FRetrieved, pkRetrieve);
				end;
			end; {if}
		end; {if}
	end else
	if (FLine = '.') and (not FInBoundary) then
	begin
		FPendingCall := pcNone;
		DoProgress(1, 1, pkRetrieve); // progress end
		DoEvent(FOnRetrieveMessage, psReady, stMessage, false); // now support retrieve method calls

		if FProcessAll then
			if FMessageNumber < FMessageCount then
			begin
				if FState <> psReady then // a retrieve method was called
					FPendingCall := pcRetrieveAllMessages else
					InternalRetrieveMessage(FMessageNumber + 1);
			end else
				DoEvent(FOnRetrieveAllMessages, FState, stAllMessages, false);
	end else
	if FState = psRetrieveMessage then // avoid trash after end
	begin
		if (Length(FLine) = 0) then
		begin
			if FSomethingReaded and FTrackingHeader then
			begin
				FTrackingHeader := false;
				DoEvent(FOnRetrieveHeader, psReady, stHeader, false);
				FState := psRetrieveMessage;
			end;
		end else
		if not FSomethingReaded then
			FSomethingReaded := true;

		if FSomethingReaded then
		begin
			MailMsj := InternalGetMessage(FMessageNumber);
			InternalBodyProc(MailMsj);

			Inc(FRetrieved, Length(FLine) + 2); // add to counter (2=CR+LF)
			DoProgress(MailMsj.FSize, FRetrieved, pkRetrieve);
		end;
	end; {if}
end;

procedure TWirelessPOP3.InternalRetrieveUIDLProc;
var
	iNumber: Integer;
	sUIDL: String;

	procedure p_Response(const Line: String);
	begin
		f_ExtractParams(Line, iNumber, sUIDL, false);
		if iNumber > 0 then InternalGetMessage(iNumber).FXUIDL := sUIDL; // assign
		DoEvent(FOnRetrieveUIDL, psReady, stUIDL, true);
	end;

begin
	if FResponseLine then // if waitting +OK or -ERR
	begin
		FResponseLine := false;
		if StrLComp(PChar(FLine), '+OK', 3) <> 0 then
		begin
			DoError(ekRetrieveUIDL, true); // item bad
			if FProcessAll then DoAbort(akRetrieveAllUIDLs); // everything bad
		end else
		if not FProcessAll then // format for single message is: +OK <n> <uidl>
			p_Response(Copy(FLine, 5, Length(FLine)));
	end else
	if (FLine = '.') then
		DoEvent(FOnRetrieveAllUIDLs, FState, stAllUIDLs, false) else
	if (Length(FLine) > 0) then
		p_Response(FLine); // format for multiline is: <n> <uidl> (without +OK)
end;

procedure TWirelessPOP3.InternalBodyProc(MailMsj: TMailMessage);
var
	iPos: Integer;
	sTemp: String;
	bBoundary: Boolean;
begin
	if FMailPart = nil then
	begin
		if MailMsj.FMailParts.Count = 0 then MailMsj.FRawData.Clear;
		FMailPart := TMailPart.Create; // create a new mailpart
		FMailPart.FMailMessage := MailMsj;
		MailMsj.FMailParts.Add(FMailPart);
	end;

	if FStoreRawData then MailMsj.FRawData.Add(FLine);
	bBoundary := false;

	if (Length(FLine) = 0) and (not FTrackingHeader) then
	begin
		if FSeekLabels then // first empty line after labels
		begin
			FSeekLabels := false;
			Exit; // nothing to parse
		end;
	end else
	if (not FSeekLabels) and (Length(FLine) > 0) then
	begin
		if FLine[1] = '-' then // boundary apears with no previous advice
		begin // search in boundary list
			if FBoundary.IndexOf(FLine) >= 0 then
			begin
				bBoundary := true;
				FInBoundary := true;
			end else // search as boundary end
			if FBoundary.IndexOf(Copy(FLine, 1, Length(FLine) - 2)) >= 0 then
			begin
				bBoundary := true;
				FInBoundary := false;
			end;
		end; {if}

		FSeekLabels := bBoundary; // if boundary was found, seek labels again
	end;

	if FSeekLabels and (not bBoundary) then
	begin
		iPos := Pos('boundary=', FLine);

		if iPos > 0 then
		begin
			iPos := Pos('"', FLine);
			if iPos > 0 then // boundary between quotes (")
			begin
				sTemp := '--' + Trim(Copy(FLine, iPos + 1, Length(FLine)));
				iPos := Pos('"', sTemp); // find the other quote (")
				if iPos > 0 then
				begin
					SetLength(sTemp, iPos - 1);
					FBoundary.Add(sTemp); // add boundary to list
				end;
			end else
			begin	// boundary without quotes
				sTemp := '--' + Trim(Copy(FLine, 10, Length(FLine)));
				iPos := Pos(';', sTemp); // can finish with semicolon (;)
				if iPos > 0 then
				begin
					SetLength(sTemp, iPos - 1);
					FBoundary.Add(sTemp); // add boundary to list
				end;
			end;
		end; {if}

		// search a label
		if (Length(FLine) > 0) and (FLine[1] <> #32) and (FLine[1] <> #9) then
		begin
			iPos := Pos(':', FLine);
			if iPos > 1 then
			begin
				FCurrLabel := FMailPart.FMIMELabels.AddLabel(Copy(FLine, 1, iPos - 1));
				FLine := Trim(Copy(FLine, iPos + 2, Length(FLine)));
			end;
		end;
	end else
		FCurrLabel := nil;

	if FCurrLabel <> nil then // found a label
		FCurrLabel.AddValue(FLine) else
	if (Length(FLine) > 0) and bBoundary then // reading boundary
		FMailPart := nil else
		FMailPart.FBody.Add(FLine); // add line to MailPart
end;

procedure TWirelessPOP3.DoWaitFor(const Step: TPop3Step);
var
	Buffer: PChar;
	Count: Integer;
begin
	if not Assigned(FOnBlockingRead) then Exit;
	Exclude(FSteps, Step);

	repeat
		DoBlockingRead(Buffer, Count);
		ReadData(Buffer, Count);
	until (Step in FSteps) or FErrorReceived;
end;

procedure TWirelessPOP3.DoBlockingRead(var Buffer: PChar; var Count: Integer);
begin
	if Assigned(FOnBlockingRead) then FOnBlockingRead(Self, Buffer, Count);
end;

end.
